Leetcode_292_Nim Game


You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.


Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.


For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.


      思路:

      (1)题意为给定一堆石头,你和朋友每次可以从中选取1、2、3块石头,谁拿到最后一块石头谁就取胜。请问在你先拿的情况下每次是否能够取胜。这道题属于非常简单的题,这里仅作为存档。

      (2)每次可以拿1、2、3块石头,当数量为4时,发现赢不了;同理,当数量为8、12、16…..4n (n>1)时,同样赢不了。可发现当数量为4的倍数时,永远也赢不了。

      (3)希望本文对你有所帮助。


          算法代码实现如下:

package leetcode;

public class Nim_Game {
    public boolean canWinNim(int n) {

        if (n > 0 && n % 4 == 0) {
            return false;
        } else {
            return true;
        }

    }
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值